



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[WPF 容易忽视的细节] —— x:Name与Name属性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[WPF 容易忽视的细节] —— x:Name与Name属性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 14:22:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一、前言</h1>
<p>WPF使用XAML来对界面进行编写，界面与后台逻辑分离。我们也可以写Style、Trigger来实现一些界面效果，</p>
<p>这些都是通过<strong>Name</strong>来定位控件的，例如Setter.TargetName、Trigger.SourceName和Binding的ElementName等。</p>
<p>而这些Name都是通过设置控件的x:Name来定义的，如&lt;Button x:Name="Button1" /&gt;</p>
<p>但是，XAML中有x:Name和Name这两个属性，究竟它们有什么区别呢？</p>
<p>本专题就来探究一下x:Name和Name的区别，它们的本质又是什么？</p>
<h2>二、XAML与Code-Behind</h2>
<p>在编写WPF程序时，通常需要分别编写前台XAML代码和后台Code-Behind代码（不使用MVVM时）。</p>
<p>WPF通过一个<strong>partial</strong>关键字，将一个类的定义切分为两部分：XAML和Code-Behind。</p>
<p>其中XAML交给设计师设计，Code-Behind交给程序员写业务逻辑，从而实现分离（虽然大部分时候全部都是程序员完成的）。</p>
<p>我们在XAML上写标签，其实与后台写代码是等效的。只要你想，完全可以只使用XAML或者只是用Code-Behind来写程序。</p>
<p>示例：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;!--  只使用xaml编写一个窗体  --&gt;<br />
&lt;!--  只使用一个单独的xaml文件 --&gt;<br />
&lt;Window x:Class="Cnblog.OnlyXaml"<br />
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"<br />
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"<br />
        Title="OnlyXaml"<br />
        Width="300"<br />
        Height="300"&gt;<br />
    &lt;Grid&gt;<br />
        &lt;Button Width="100"<br />
                Height="100"<br />
                Click="ButtonClick"&gt;<br />
            Button<br />
        &lt;/Button&gt;<br />
    &lt;/Grid&gt;<br />
    &lt;x:Code&gt;<br />
        private void ButtonClick(object sender, RoutedEventArgs e)<br />
        {<br />
        MessageBox.Show(&amp;quot;Button Click&amp;quot;);<br />
        }<br />
    &lt;/x:Code&gt;<br />
&lt;/Window&gt;</pre>
</div>
<p>只使用xaml编写一个窗体</p></div>
<div>
<div>
<pre class="prettyprint linenums">namespace Cnblog<br />
{<br />
    // 只使用Code-Behind编写一个窗体<br />
    // 只使用一个单独的OnlyCode.cs文件<br />
    public class OnlyCode :Window<br />
    {<br />
        public OnlyCode()<br />
        {<br />
            // button<br />
            var button = new Button { Content = "Button",Width = , Height = };<br />
            button.Click += ButtonClick;

            // grid<br />
            var grid = new Grid();<br />
            grid.Children.Add(button);

            this.Width = ;<br />
            this.Height = ;<br />
            this.Title = "OnlyCode";<br />
            this.Content = grid;<br />
        }

        void ButtonClick(object sender, RoutedEventArgs e)<br />
        {<br />
            MessageBox.Show("Button Click");<br />
        }<br />
    }<br />
}</pre>
</div>
<p>只使用Code-Behind编写一个窗体</p></div>
<p>上面例子，分别只使用XAML和Code-Behind来定义一个窗体，但是最终的效果都是一样的。</p>
<p>当然，如果单独使用其中一种，必然让编程变得很痛苦，这里我只是想表明有这个可能性（因为下面会用到），实际中不会这么做。</p>
<p>结论：虽然编码方式不一样，但是效果是一样的，编译器其实对XAML进行编译生成BAMP，根据标签创建相应对象。</p>
<p>这个与本专题无关，但是下面要将要用到相关内容，先说明一下。</p>
<h2>三、XAML中x:Name和Name最终效果相同</h2>
<p>如果你在xaml中创建一个控件，并同时对x:Name和Name两个属性进行赋值，那么编译器就会提醒你：Name被设置了多次。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14164656-b1aa154ee7924936a845b4288995bb60.jpg" /></p>
<p>当然，如果你觉得这个不够有说服力，那么下面这段程序可能也能够佐证：</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;!-- 两个Button分别使用x:Name和Name --&gt;<br />
&lt;Window x:Class="Cnblog.SetName"<br />
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"<br />
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"<br />
        Title="SetName"<br />
        Width="300"<br />
        Height="300"&gt;<br />
    &lt;StackPanel&gt;<br />
        &lt;Button x:Name="Button1" Loaded="ButtonLoaded" /&gt;<br />
        &lt;Button Name="Button2" Loaded="ButtonLoaded" /&gt;<br />
    &lt;/StackPanel&gt;<br />
    &lt;x:Code&gt;<br />
        private void ButtonLoaded(object sender, RoutedEventArgs e)<br />
        {<br />
        var button = (Button)sender;<br />
        button.Content = button.Name;<br />
        }<br />
    &lt;/x:Code&gt;<br />
&lt;/Window&gt;</pre>
</div>
<p>两个Button分别使用x:Name和Name</p></div>
<p>效果图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14164828-4fd8dd62e2984b77a08c3f47897ffe60.jpg" /></p>
<p>下面是用IL的截图，两者无区别。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14164846-52cf340b01434197aadd06b2741de903.jpg" /></p>
<p>结论：</p>
<p>XAML中使用Name其实被映射到了x:Name，x:Name才是XAML中唯一的标识，所以它们效果相同。</p>
<h2>四、不同于控件的Name属性</h2>
<p>在WPF中，很多控件拥有Name属性，例如上面我们使用Button的Name来设置Content，button.Content=button.Name。</p>
<p>是因为它们的父类FrameworkElement中都定义了Name属性，以下用<strong>SomeWpfType</strong>来代替这些类型（便于表述）。</p>
<p>下面，我们不使用XAML和x:Name，使用Code-Behind和<strong>SomeWpfType</strong>.Name来测试一下。</p>
<div>
<div>
<pre class="prettyprint linenums">namespace Cnblog<br />
{<br />
    // 使用Button的Name属性<br />
    public class SetNameByCodeBehind : Window<br />
    {<br />
        public SetNameByCodeBehind()<br />
        {<br />
            // Buttons<br />
            var button1 = new Button { Name = "Button1" };<br />
            button1.Loaded += ButtonLoaded;<br />
            var button2 = new Button { Name = "Button2" };<br />
            button2.Loaded += ButtonLoaded;

            // StackPanel<br />
            var contentPanel = new StackPanel();<br />
            contentPanel.Children.Add(button1);<br />
            contentPanel.Children.Add(button2);

            // Window<br />
            this.Title = "Set Name By Code-Behind";<br />
            this.Height = ;<br />
            this.Width = ;<br />
            this.Content = contentPanel;<br />
        }

        void ButtonLoaded(object sender, RoutedEventArgs e)<br />
        {<br />
            var button = (Button)sender;<br />
            button.Content = button.Name;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>使用Button的Name属性</p></div>
<p>效果图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14165021-5ed31226e4904da5b86f4151f24ecb29.jpg" /></p>
<p>下面，区别终于有了，我们再来看IL的内容：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14165040-f0479018d7e94d358a6228b8a5b9d11c.jpg" /></p>
<p>因为不是使用XAML书写的，所以缺少一些函数和对象，但是更重要的是：缺少两个Button对象的定义。</p>
<p>如果我们修改一下代码，再来看一下，就能清楚的知道原因了！</p>
<div>
<div>
<pre class="prettyprint linenums">namespace Cnblog<br />
{<br />
    public class SetNameByCodeBehind : Window<br />
    {<br />
        // 修改为internal的对象，取代之前的局部变量<br />
        internal Button Button1;<br />
        internal Button Button2;

        public SetNameByCodeBehind()<br />
        {<br />
            // Buttons<br />
            Button1 = new Button { Name = "Button1" };<br />
            Button1.Loaded += ButtonLoaded;<br />
            Button2 = new Button { Name = "Button2" };<br />
            Button2.Loaded += ButtonLoaded;

            // StackPanel<br />
            var contentPanel = new StackPanel();<br />
            contentPanel.Children.Add(Button1);<br />
            contentPanel.Children.Add(Button2);

            // Window<br />
            this.Title = "Set Name By Code-Behind";<br />
            this.Height = ;<br />
            this.Width = ;<br />
            this.Content = contentPanel;<br />
        }

        void ButtonLoaded(object sender, RoutedEventArgs e)<br />
        {<br />
            var button = (Button)sender;<br />
            button.Content = button.Name;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>使用Button的Name属性2</p></div>
<p>再来看一下IL的内容：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/533942/201310/14165207-9553c5ece3694766ab4698bcc5e775b6.jpg" /></p>
<p>结论：</p>
<p>x:Name不是<strong>SomeWpfType</strong>.Name，当我们设置了x:Name后（<strong>假设为ElementName</strong>)，</p>
<p>其实做了两件事情：</p>
<p>1. 创建一个internal的对象，对象名字为<strong>ElementName</strong>，它其实是一个对此<strong>SomeWpfType</strong>类型对象的引用；</p>
<p>internal SomeWpfType&nbsp;<strong>ElementName</strong>&nbsp;= new&nbsp;<strong>SomeWpfType</strong>();// 假设<strong>SomeWpfType</strong>为我们定义的类型。</p>
<p>2. 设置此对象的Name属性，</p>
<p><strong>ElementName</strong>.Name = "<strong>ElementName</strong>";。</p>
<h2>五、为什么XAML中Name与x:Name效果相同</h2>
<p>上面，我们分析<strong>SomeWpfType</strong>.Name和x:Name有很大区别，而且XAML中的设置Name不就是<strong>SomeWpfType</strong>.Name吗？</p>
<p>同Width，在XAML中设置Width，就是设置SomeWpfType.Width。</p>
<p>那么我们就去翻一下FrameworkElement的源码看看吧。</p>
<div>
<div>
<pre class="prettyprint linenums">namespace System.Windows<br />
{<br />
[StyleTypedProperty(Property = "FocusVisualStyle", StyleTargetType = typeof(Control))]<br />
    [XmlLangProperty("Language")]<br />
    [UsableDuringInitialization(true)]<br />
    public partial class FrameworkElement : UIElement, IFrameworkInputElement, ISupportInitialize, IHaveResources, IQueryAmbient<br />
    { /// &lt;summary&gt;<br />
        ///     The DependencyProperty for the Name property.<br />
        /// &lt;/summary&gt;<br />
        [CommonDependencyProperty]<br />
        public static readonly DependencyProperty NameProperty =<br />
                    DependencyProperty.Register(<br />
                                "Name",<br />
                                typeof(string),<br />
                                _typeofThis,<br />
                                new FrameworkPropertyMetadata(<br />
                                    string.Empty,                           // defaultValue<br />
                                    FrameworkPropertyMetadataOptions.None,  // flags<br />
                                    null,                                   // propertyChangedCallback<br />
                                    null,                                   // coerceValueCallback<br />
                                    true),                                  // isAnimationProhibited<br />
                                new ValidateValueCallback(System.Windows.Markup.NameValidationHelper.NameValidationCallback)); 

        /// &lt;summary&gt;<br />
        ///     Name property.<br />
        /// &lt;/summary&gt;<br />
        [Localizability(LocalizationCategory.NeverLocalize)]<br />
        [MergableProperty(false)]<br />
        [DesignerSerializationOptions(DesignerSerializationOptions.SerializeAsAttribute)]<br />
        public string Name<br />
        {<br />
            get { return (string) GetValue(NameProperty); }<br />
            set { SetValue(NameProperty, value);  }<br />
        }

         // a lot of code<br />
    }<br />
}

namespace System.Windows<br />
{<br />
    [RuntimeNamePropertyAttribute("Name")]<br />
    public partial class FrameworkElement<br />
    {<br />
          // a lot of code...<br />
    }<br />
}</pre>
</div>
<p>FrameworkElement</p></div>
<p>Name属性上貌似没有什么特别，但是另外一个局部类的定义中找到了个名为<strong>RuntimeNameProperty</strong>的特性。</p>
<p>我们就来看下它的代码吧。</p>
<div>
<div>
<pre class="prettyprint linenums">namespace System.Windows.Markup<br />
{<br />
  [AttributeUsage(AttributeTargets.Class)]<br />
  [TypeForwardedFrom("WindowsBase, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35")]<br />
  public sealed class RuntimeNamePropertyAttribute : Attribute<br />
  {<br />
    private string _name;

    public string Name<br />
    {<br />
      [TargetedPatchingOptOut("Performance critical to inline this type of method across NGen image boundaries")] get<br />
      {<br />
        return this._name;<br />
      }<br />
    }

    [TargetedPatchingOptOut("Performance critical to inline this type of method across NGen image boundaries")]<br />
    public RuntimeNamePropertyAttribute(string name)<br />
    {<br />
      this._name = name;<br />
    }<br />
  }<br />
}</pre>
</div>
<p>RuntimeNamePropertyAttribute</p></div>
<p>可以看出来这个特性使用在Class上面的，也就是这个特性，使得XAML处理Name时，映射到了x:Name，才有了前面的结论。</p>
<p>我们再来查看以下还有哪些类使用了这个特性。</p>
<p>在4个Assembly中找到了13个，比较眼熟的有：</p>
<p>Timeline、BeginStoryboard、FrameworContentElement、FramewordElement、VisualState、VisualStateGroup，</p>
<p>这些也基本都是WPF中很多常用类型的基类了。</p>
<p>结论：RuntimeNameProperty特性，使得XAML中使用Name和x:Name效果一样，当编译器遇到此特性后，</p>
<p>就将Name映射到x:Name，执行一样的操作。</p>
<h2>六、XAML中x:Name与Name并不完全等价。</h2>
<p>不是所有类型都可以使用Name，但是任何类型都可以使用x:Name。</p>
<p>只有拥有Name属性，才可以在XAML中使用Name。不同于x:Name，因为这个是附加属性。</p>
<p>并且该类型、或者其父类型标记了RuntimeNameProperty特性，才拥有与x:Name一样的效果。</p>
<p>例如：&lt;SolidColorBrush Color="Transparent" Name="ddd"/&gt;便会报错，因为SolidColorBrush没有Name属性。</p>
<p>只能使用x:Name。&lt;SolidColorBrush Color="Transparent" x:Name="ddd"/&gt;</p>
<h2>七、其他</h2>
<p>1、分析为什么要有x:Name</p>
<p>前面提到，XAML中经常需要通过名字来定位某个控件或对象，而SomeWpfType的Name属性，只是一个DP，我们可以设置两个控件拥有相同的Name属性。</p>
<p>那么这样就非常不利于定位控件，因为Name不是一个唯一的标识了。</p>
<p>使用对象的引用有两个好处：</p>
<p>1.在特定的范围域内，能够保证它的唯一性；</p>
<p>2.在视图树中查找某个对象时，通过引用对象的名称比查找Name属性更加简单。</p>
<p>2. MSDN上对着几个名词的定义</p>
<blockquote><p><a href="http://msdn.microsoft.com/query/dev11.query?appId=Dev11IDEF1&amp;l=EN-US&amp;k=k(System.Windows.FrameworkElement.Name);k(VS.XamlEditor);k(TargetFrameworkMoniker-.NETFramework,Version%3Dv4.5)&amp;rd=true" rel="external nofollow noreferrer"><strong>FrameworkElement.Name</strong></a>&nbsp;- Gets or sets the identifying name of the element. The name provides a reference so that code-behind, such as event handler code, can refer to a markup element after it is constructed during processing by a XAML processor.</p>
<p>Remark:</p>
<p>The most common usage of this property is to specify a XAML element name as an attribute in markup.</p>
<p>This property essentially provides a WPF framework-level convenience property to set the XAML&nbsp;<a href="http://msdn.microsoft.com/en-us/library/ms752290.aspx" rel="external nofollow noreferrer">x:Name Directive</a>.</p>
<p>Names must be unique within a namescope. For more information, see&nbsp;<a href="http://msdn.microsoft.com/en-us/library/ms746659.aspx" rel="external nofollow noreferrer">WPF XAML Namescopes</a>.</p></blockquote>
<blockquote><p><a href="http://msdn.microsoft.com/en-us/library/ms752290.aspx" rel="external nofollow noreferrer">x:Name Directive</a>&nbsp;- Uniquely identifies XAML-defined elements in a XAML namescope. XAML namescopes and their uniqueness models can be applied to the instantiated objects, when frameworks provide APIs or implement behaviors that access the XAML-created object graph at run time.</p>
<p>Remark:</p>
<p>The value of an&nbsp;x:Name&nbsp;directive usage must be unique within a XAML namescope. By default when used by .NET Framework XAML Services API, the primary XAML namescope is defined at the XAML root element of a single XAML production, and encompasses the elements that are contained in that XAML production. Additional discrete XAML namescopes that might occur within a single XAML production can be defined by frameworks to address specific scenarios. For example, in WPF, new XAML namescopes are defined and created by any template that is also defined on that XAML production. For more information about XAML namescopes (written for WPF but relevant for many XAML namescope concepts), see&nbsp;<a href="http://msdn.microsoft.com/en-us/library/ms746659.aspx" rel="external nofollow noreferrer">WPF XAML Namescopes</a>.</p></blockquote>
<p>希望对大家有帮助。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyyejdq.html">Linux命令详解之&mdash;tail命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwlv4y9.html">UIPickerView的使用&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1w6vx8.html">android Studio gradle so的加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd66nm8.html">初识 AutoLayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp0w4jq.html">HtmlUnit&plus;Jsoup 解决爬虫无法解析执行javascript的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrmpe9.html">WIN10怎么安装SQL server2000数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjp5ng8.html">洛谷 P1045 &amp;amp&semi; &lbrack;NOIP2003普及组&rsqb; 麦森数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnyoe9.html">mongoDB数据库的安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyyn1jq.html">Java多线程之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkp4jq.html">BZOJ&period;5249&period;&lbrack;九省联考2018&rsqb;iiidx&lpar;贪心 线段树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwo30q.html">【原创 Hadoop&amp;amp&semi;Spark 动手实践 9】Spark SQL 程序设计基础与动手实践（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj6yee9.html">（原）pycharm中debugger时console如何打开</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2p4nz9.html">《软件测试自动化之道》读书笔记 之 基于Windows的UI测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25pr0wq.html">Ubuntu12&period;04  内核树建立</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5gnd9.html">npm私服搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pnk5z8.html">使用pip install XX 命令时报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveo0my9.html">sqlserver ssms ctrl&plus;e快捷键问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/953kg6e8.html">cocos2dx字体描边</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15r3729.html">linux下网络编程学习&mdash;&mdash;入门实例ZZ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8km556r9.html">使用httpModules做一些事</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95g5g40q.html">Jfinal  QuartzPlugin 简单使用案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1x4d5q.html">Android开发艺术探索学习笔记（六）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjn4r49.html">Prim Algoritm&lpar;最小生成树&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7opl5j8.html">Maven 入门&mdash;&mdash;认识 Maven</a>
			</li>
						<li><a href="https://www.batexi.com/a/q257mr3q.html">Solidity的delete操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5j0ddq.html">Semaphore 信号量</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj35k39.html">Nginx&plus;uwsgi&plus;Django 的web应用环境部署-完整记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4pjdz9.html">RocketMQ专题1：入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjng4l9.html">ApiGen 4&period;0配置项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv7ngl8.html">Iframe  父页面自动获取子页面的高度</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
